
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ezjkdict.h"

int main(int argc, char **argv)
{
  ezjk_dict_t jkdictbuf;

  printf("\xef\xbb\xbf");

  while (fread(&jkdictbuf, sizeof(ezjk_dict_t), 1, stdin) == 1)
  {
    int unilen;
    WCHAR *unistrbuf;
    int utflen;
    char *utfstrbuf;

    if (jkdictbuf.hidden)
    {
      printf("|1|");
    }
    else
    {
      printf("|0|");
    }

    unilen = MultiByteToWideChar(932, 0, jkdictbuf.jpword_sjis, -1, 0, 0);
    unistrbuf = malloc(unilen << 1);
    MultiByteToWideChar(932, 0, jkdictbuf.jpword_sjis, -1, unistrbuf, unilen);
    utflen = WideCharToMultiByte(65001, 0, unistrbuf, -1, 0, 0, 0, 0);
    utfstrbuf = malloc(utflen);
    WideCharToMultiByte(65001, 0, unistrbuf, -1, utfstrbuf, utflen, 0, 0);
    printf("%s|", utfstrbuf);
    free(utfstrbuf);
    free(unistrbuf);

    unilen = MultiByteToWideChar(949, 0, jkdictbuf.krword_euckr, -1, 0, 0);
    unistrbuf = malloc(unilen << 1);
    MultiByteToWideChar(949, 0, jkdictbuf.krword_euckr, -1, unistrbuf, unilen);
    utflen = WideCharToMultiByte(65001, 0, unistrbuf, -1, 0, 0, 0, 0);
    utfstrbuf = malloc(utflen);
    WideCharToMultiByte(65001, 0, unistrbuf, -1, utfstrbuf, utflen, 0, 0);
    printf("%s|", utfstrbuf);
    free(utfstrbuf);
    free(unistrbuf);

    printf("%s|", jkdictbuf.part_of_speech);

    printf("%s|\n", jkdictbuf.attributes);
  }

  fflush(NULL);

  return 0;
}
