
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ezjkdict.h"

static int _ezjk_find_delim(void);

static int _ezjk_find_delim(void)
{
  char ch;

  while ((ch = (char)getc(stdin)) != EOF)
  {
    if (ch == '|')
    {
      return 1;
    }
  }

  return 0;
}

int main(int argc, char **argv)
{
  ezjk_dict_t jkdictbuf;
  char ch;
  char utfstrbuf[128];
  int i;
  int unilen;
  WCHAR *unistrbuf;

  while (_ezjk_find_delim())
  {
    memset(&jkdictbuf, 0, sizeof(ezjk_dict_t));

    jkdictbuf.hidden = (char)getc(stdin) - '0';

    getc(stdin);

    for (i = 0; i < sizeof(utfstrbuf); i++)
    {
       utfstrbuf[i] = (char)getc(stdin);
       if (utfstrbuf[i] == '|')
       {
         utfstrbuf[i] = '\0';
         break;
       }
    }
    unilen = MultiByteToWideChar(65001, 0, utfstrbuf, -1, 0, 0);
    unistrbuf = malloc(unilen << 1);
    MultiByteToWideChar(65001, 0, utfstrbuf, -1, unistrbuf, unilen);
    WideCharToMultiByte(932, 0, unistrbuf, -1, jkdictbuf.jpword_sjis,
      sizeof(jkdictbuf.jpword_sjis), 0, 0);
    jkdictbuf.jpword_sjis[sizeof(jkdictbuf.jpword_sjis) - 1] = '\0';
    free(unistrbuf);

    for (i = 0; i < sizeof(utfstrbuf); i++)
    {
       utfstrbuf[i] = (char)getc(stdin);
       if (utfstrbuf[i] == '|')
       {
         utfstrbuf[i] = '\0';
         break;
       }
    }
    unilen = MultiByteToWideChar(65001, 0, utfstrbuf, -1, 0, 0);
    unistrbuf = malloc(unilen << 1);
    MultiByteToWideChar(65001, 0, utfstrbuf, -1, unistrbuf, unilen);
    WideCharToMultiByte(949, 0, unistrbuf, -1, jkdictbuf.krword_euckr,
      sizeof(jkdictbuf.krword_euckr), 0, 0);
    jkdictbuf.krword_euckr[sizeof(jkdictbuf.krword_euckr) - 1] = '\0';
    free(unistrbuf);

    for (i = 0; i < sizeof(jkdictbuf.part_of_speech); i++)
    {
       jkdictbuf.part_of_speech[i] = (char)getc(stdin);
       if (jkdictbuf.part_of_speech[i] == '|')
       {
         jkdictbuf.part_of_speech[i] = '\0';
         break;
       }
    }

    for (i = 0; i < sizeof(jkdictbuf.attributes); i++)
    {
       jkdictbuf.attributes[i] = (char)getc(stdin);
       if (jkdictbuf.attributes[i] == '|')
       {
         jkdictbuf.attributes[i] = '\0';
         break;
       }
    }

    fwrite(&jkdictbuf, sizeof(ezjk_dict_t), 1,stdout);
  }

  fflush(NULL);

  return 0;
}
